c   main program
c   range of full distribution will be 3.0E-18 .. 3.0E+18
c   range of narrow distribution will be -20 .. 20
c   will halve this until < 2.36E-38
c   choose 2/3 of zeroes from narrow distribution

c      endpoints of narrow distribution range
       real nmin, nmax
c      endpoints of full distribution range
       real fmin, fmax
c      number of polynomials to be generated
       integer maxit
c      loop counter
       integer ind
c      zeroes
       real i, j, k
c      array of coefficients of the polynomial
       real cub(0:3)
       real exp

	print *, 'exponent'

	read *, exp


	callSetSd(16777213)
        nmin = -1
        nmax = 1
        fmin =  -3 * 10**10
        fmax = 3 * 10**10

c       loops through to generate polynomials with one zero from the 
c       full distribution and two from the narrow distribution
c       until the narrow distribution is |limits| < 2.36E-38 or
c       maxit has been reached

*        PRINT *, 'Enter number of polynomials to be generated:'
*        READ *, maxit
	maxit=20

        OPEN (unit =10, FILE = 'test3')
50        DO 100 ind = 1, maxit, 1
             i = generate(fmin, fmax)
             j = generate(nmin, nmax)
             k = generate(nmin, nmax)
             CALL polycoeff(i, j, k, cub)
*             PRINT 200, cub(0), cub(1), cub(2), cub(3)
             WRITE (10, 200) cub(0), cub(1), cub(2), cub(3)
 100       continue
             nmin = nmin/2
             nmax = nmax/2
             IF (nmax .LE. 2.36*(10.**-10)) THEN
		 close(10)
                 STOP 'narrow distribution too small'
             END IF
	   goto 50
 200       FORMAT(4E16.8)
	   close(10)
           stop
           end

	subroutine SetSd(X)
	integer X, Y, M
	common /Rand/ Y
	parameter (M=233280)
	Y=mod(X, M)
	return
	end

	real function Random()
	integer Y, A, C, M
	common /Rand/ Y
	parameter (A=9301, C=49297, M=233280)
	Y=A*Y+C
	if (Y.lt.0)then
	   Y=Y+2147483647+1
	endif
	Y=mod(Y, M)
	Random=real(Y)/real(M)
	return
	end



       real function generate(min, max)
*      generates a random number from the range [min,max] 
*      from a uniform  distribution, where Random generates
*      a random number from a uniformly distribution from 
*      0 to 1
        real min, max
          generate =   min + (max - min) * Random() 
          return
       end 

       SUBROUTINE polycoeff(z1, z2, z3, poly)
*      fills an array called poly with  4 coefficients 
*      of a cubic polynomial given its 3 roots
         real z1, z2, z3, poly(0:3)
         poly(0) = 1.0
         poly(1) = - z1 - z2 - z3
         poly(2) = z1*z2 - z3*z1 + z3*z2
         poly(3) = - ( z1 * z2 * z3 )
         return
       end
 

